//+------------------------------------------------------------------+
//|                                            Repeated median slope |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  PaleVioletRed
#property indicator_color2  Magenta
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int    Price              = PRICE_CLOSE;
extern int    Length             = 200;
extern int    Anchor             = 0;
extern string IndicatorUniqueID  = "rml";
extern color  TextColor          = DimGray;
extern color  PositiveAngleColor = Green;
extern color  NegativeAngleColor = Red;
extern int    YShift             = 10;

//
//
//
//
//

double values[];
double rrme[];
double rrmr[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
      SetIndexBuffer(0, rrme);
      SetIndexBuffer(1, rrmr);
      SetIndexBuffer(2, values);
   IndicatorShortName("Repeated median line ("+Length+")");      
   return (0);
}
int deinit()
{
   string lookFor       = IndicatorUniqueID+":";
   string lookForLength = StringLen(lookFor);
   for (int i = ObjectsTotal(); i>= 0; i--)
   {
      string name = ObjectName(i);
      if (StringSubstr(name,0,lookForLength)==lookFor) ObjectDelete(name);
   }
   return (0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double worksFull[];
double worksTemp[];
double workiFull[];
double workiTemp[];

//
//
//
//
//

int start()
{
   int limit,counted_bars = IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (ArraySize(worksFull)!=Length)
           {
               ArrayResize(worksFull,Length);
               ArrayResize(worksTemp,Length-1);
               ArrayResize(workiFull,Length);
               ArrayResize(workiTemp,Length-1);
           }               

   //
   //
   //
   //
   //
   
      for (int i = limit; i >= 0; i--)  values[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      for (int j = 0; j<Length; j++)
      {
            int c = 0;
            for (int k=0; k<Length; k++)
            {
               if (k==j) continue;
                  worksTemp[c] = (  values[Anchor+k]-  values[Anchor+j])/(j-k);
                  workiTemp[c] = (j*values[Anchor+k]-k*values[Anchor+j])/(j-k);
               c++;
            }
            
            //
            //
            //
            //
            //
            
            ArraySort(worksTemp);
            ArraySort(workiTemp);
               double index = (Length-2)/2.0;
               int    ind   = index;
               if (ind == NormalizeDouble(index,5))
                  {
                     worksFull[j] = worksTemp[ind];
                     workiFull[j] = workiTemp[ind];
                  }                        
               else  
                  {
                     worksFull[j] = worksTemp[ind]/2.0+worksTemp[ind+1]/2.0;
                     workiFull[j] = workiTemp[ind]/2.0+workiTemp[ind+1]/2.0;
                  }                     
      }

      //
      //
      //
      //
      //
                  
      ArraySort(worksFull);
      ArraySort(workiFull);
            index = (Length-1)/2.0;
            ind   = index;
            if (ind == NormalizeDouble(index,5))
               {
                  double slope     = worksFull[ind];
                  double intercept = workiFull[ind];
               }                  
            else
               {
                  slope     = worksFull[ind]/2.0+worksFull[ind+1]/2.0;
                  intercept = workiFull[ind]/2.0+workiFull[ind+1]/2.0;
               }                  
            
         //
         //
         //
         //
         //
         
                        
      for (k=0; k< Length; k++) rrme[k+Anchor] = intercept-slope*k;
      for (k=0; k<=Anchor; k++) rrmr[Anchor-k] = intercept+slope*k;
      SetIndexDrawBegin(0,Bars-Length-Anchor);
      SetIndexDrawBegin(1,Bars-Anchor-1);
      showAngle(intercept-slope*(Length-1),Time[Anchor+Length-1],intercept,Time[Anchor]);

   //
   //
   //
   //
   //
   
   return (0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void showAngle(double price1, datetime time1, double price2, datetime time2)
{
   string name   = IndicatorUniqueID+":0";
   ObjectCreate(name,OBJ_TRENDBYANGLE,0,time1,price1);
      ObjectSet(name,OBJPROP_TIME1,time1);
      ObjectSet(name,OBJPROP_PRICE1,price1);
      ObjectSet(name,OBJPROP_TIME2,time2);
      ObjectSet(name,OBJPROP_PRICE2,price2);
      ObjectSet(name,OBJPROP_COLOR,CLR_NONE);
      ObjectSet(name,OBJPROP_RAY,false);

      WindowRedraw();
      double angle    = ObjectGet(name,OBJPROP_ANGLE);
      color  theColor = PositiveAngleColor;
         if (angle>180) { angle = angle-360; theColor = NegativeAngleColor; }
            showLabel(IndicatorUniqueID+":1",50,YShift,TextColor," Repeated median line "+Length+" angle :");
            showLabel(IndicatorUniqueID+":2",10,YShift,theColor ,DoubleToStr(angle,2),9,"Arial bold");
}

//
//
//
//
//

void showLabel(string element, int x, int y, color ecolor=Silver, string text = "", int fontsize = 9, string fontname="Arial", int angle=0)
{
   string name = element;
   ObjectCreate(name, OBJ_LABEL,0, 0, 0);
      ObjectSet(name, OBJPROP_XDISTANCE, x);
      ObjectSet(name, OBJPROP_YDISTANCE, y);
      ObjectSet(name, OBJPROP_BACK, FALSE);
      ObjectSet(name, OBJPROP_CORNER, 3);
      ObjectSet(name, OBJPROP_ANGLE, angle);
      ObjectSetText(name, text, fontsize, fontname, ecolor);
}